.386
.model flat, stdcall
option casemap :none   
include		\masm32\include\windows.inc
include		\masm32\include\user32.inc
include		\masm32\include\kernel32.inc
include		\masm32\include\comctl32.inc

includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\comctl32.lib
;************PROCEDURE DEFINITION*****************
FiberFunc proto:dword
DlgProc proto:dword,:dword,:dword,:dword
;************MESSAGE WOULD BE PROCEDURED***********
	;1.	PROCEDURE WM_CLOSE			 
	;2.	PROCEDURE WM_INITDIALOG
	;3.	PROCEDURE WM_COMMAND

;************MACRO && STRUCT**********************
FIBERINFO struct 
	pFiberUI DWORD ?;User interface fiber execution context
	hwnd	 HWND  ?;Handle of main UI window
	bps	 DWORD ?;State of background processing
FIBERINFO ends
PFIBERINFO typedef ptr FIBERINFO
; ---------------------
    ; literal string MACRO
    ; ---------------------
      literal MACRO quoted_text:VARARG
        LOCAL local_text
        .data
          local_text db quoted_text,0
        .code
        EXITM <local_text>
      ENDM
; --------------------------------
    ; string address in INVOKE format
    ; --------------------------------
      SADD MACRO quoted_text:VARARG
        EXITM <ADDR literal(quoted_text)>
      ENDM

;********************CONST VALUE********************************
.const 
  IDD_COUNTER    equ             101
  IDI_COUNTER    equ             102
  IDC_FIBER      equ             1000
  IDC_ANSWER     equ             1001
  IDC_COUNT      equ             1002

	BPS_STARTOVER	equ	1;Start the background processing from the beginning.
	BPS_CONTINUE	equ	2;Continue the background processing.
	BPS_DONE		equ	3;There is no background processing to do.

;**********************DATA SEGMENT ***************************
.data  
pFiberCounter   dword NULL ;Counter fiber execution context
fQuit dword FALSE
.data? 
hInstance	dd	?
msg MSG <>
g_FiberInfo FIBERINFO <>;A global that contains application state information. This 
; global is accessed directly by the UI fiber and indirectly
; by the background processing fiber.